import numpy as np
import scipy as sp
import os
import matplotlib.pyplot as plt
from scipy.optimize import curve_fit

## Sigma+ - 0 Gauss
# directory = r'C:/Users/pc2009/Dropbox (Heriot-Watt University Team)/RES_EPS_Quantum_Photonics_Lab/Experiments/Current Experiments/SiC_Vanadium/PLE_Scan/PLE at Different Magnetic Fields/0_Gauss/'
# Freq_x = os.path.join(directory, 'D1_1uW_0Gauss_10sx3_QWP_128_32022_12_16_15_13_run_1_THz.txt')
# Counts_y = os.path.join(directory, 'D1_1uW_0Gauss_10sx3_QWP_128_32022_12_16_15_13_run_1_Counts.txt')
# #Power_y = os.path.join(directory, 'D1_1uW_0Gauss_10sx3_QWP_128_32022_12_16_15_13_run_1_uW.txt')
# ### Sigma-
# Freq_x2 = os.path.join(directory, 'D1_1uW_0Gauss_10sx3_QWP_37_32022_12_16_15_49_run_1_THz.txt')
# Counts_y2 = os.path.join(directory, 'D1_1uW_0Gauss_10sx3_QWP_37_32022_12_16_15_49_run_1_Counts.txt')
# #Power_y2 = os.path.join(directory, 'D1_1uW_0Gauss_10sx3_QWP_37_32022_12_16_15_49_run_1_uW.txt')
# #
# #### Sigma+ - 600 Gauss
# directory = r'C:/Users/pc2009/Dropbox (Heriot-Watt University Team)/RES_EPS_Quantum_Photonics_Lab/Experiments/Current Experiments/SiC_Vanadium/PLE_Scan/PLE at Different Magnetic Fields/600_Gauss/'
# Freq_x = os.path.join(directory, 'D1_1uW_600Gauss_15sx3_QWP_128_32022_12_16_12_44_run_1_THz.txt')
# Counts_y = os.path.join(directory, 'D1_1uW_600Gauss_15sx3_QWP_128_32022_12_16_12_44_run_1_Counts.txt')
# #Power_y = os.path.join(directory, 'D1_1uW_600Gauss_15sx3_QWP_128_32022_12_16_12_44_run_1_uW.txt')
# ### Sigma-
# Freq_x2 = os.path.join(directory, 'D1_1uW_600Gauss_15sx3_QWP_37_32022_12_16_13_40_run_1_THz.txt')
# Counts_y2 = os.path.join(directory, 'D1_1uW_600Gauss_15sx3_QWP_37_32022_12_16_13_40_run_1_Counts.txt')
# #Power_y2 = os.path.join(directory, 'D1_1uW_600Gauss_15sx3_QWP_37_32022_12_16_13_40_run_1_uW.txt')

# # #### Sigma+ - 1000 Gauss
directory = r'C:/Users/pc2009/Dropbox (Heriot-Watt University Team)/RES_EPS_Quantum_Photonics_Lab/Experiments/Current Experiments/SiC_Vanadium/PLE_Scan/PLE at Different Magnetic Fields/1000_Gauss/Splitting/'
Freq_x = os.path.join(directory, 'D1_1uW_1000Gauss_10sx3_QWP_1282022_12_20_11_02_run_1_THz.txt')
Counts_y = os.path.join(directory, 'D1_1uW_1000Gauss_10sx3_QWP_1282022_12_20_11_02_run_1_Counts.txt')
#Power_y = os.path.join(directory, 'D1_1uW_1000Gauss_10sx3_QWP_1282022_12_20_11_02_run_1_uW.txt')
# ### Sigma-
Freq_x2 = os.path.join(directory, 'D1_1uW_1000Gauss_10sx3_QWP_372022_12_20_11_50_run_1_THz.txt')
Counts_y2 = os.path.join(directory, 'D1_1uW_1000Gauss_10sx3_QWP_372022_12_20_11_50_run_1_Counts.txt')
#Power_y2 = os.path.join(directory, 'D1_1uW_1000Gauss_10sx3_QWP_372022_12_20_11_50_run_1_uW.txt')


### Load the data
### 0 Gauss ###
x = np.loadtxt(Freq_x)
y = np.loadtxt(Counts_y)
#z = np.loadtxt(Power_y)
##
x2 = np.loadtxt(Freq_x2)
y2 = np.loadtxt(Counts_y2)
#z2 = np.loadtxt(Power_y2)

### Order the point in both arrays (due to the mode hoping the points are not in order)
ind = np.argsort(x)
x = x[ind]
y = y[ind]
#
ind_2 = np.argsort(x2)
x2 = x2[ind_2]
y2 = y2[ind_2]

### Normalize by the power (z)
# y = y/z
# y2 = y2/z2

### Define Fitting/Plotting Range
x_range_1 = x[(x>234.420) & (x<234.430)]
y_range_1 = y[(x>234.420) & (x<234.430)]
#z_range_1 = z[(x>234.420) & (x<234.430)]

x_range_2 = x2[(x2>234.420) & (x2<234.430)]
y_range_2= y2[(x2>234.420) & (x2<234.430)]
#z_range_2= z2[(x2>234.420) & (x2<234.430)]

### Error on the counts - Square root of the Counts - divided by 10 to convert in cps
### 0 Gauss ###
# y_err_1 = np.sqrt(y_range_1)/10     #File: D1_1uW_0Gauss_10sx3_QWP_128_32022_12_16_15_13_run_1_Counts
# y_err_2 = np.sqrt(y_range_2)/10     #File: D1_1uW_0Gauss_10sx3_QWP_128_32022_12_16_15_13_run_1_Counts
#
# y_range_1 = y_range_1/10
# y_range_2 = y_range_2/10

### 600 Gauss ###
# y_err_1 = np.sqrt(y_range_1)/15     #File: D1_1uW_600Gauss_15sx3_QWP_128_32022_12_16_12_44_run_1_Counts
# y_err_2 = np.sqrt(y_range_2)/15     #File: D1_1uW_600Gauss_15sx3_QWP_37_32022_12_16_13_40_run_1_Counts
#
# y_range_1 = y_range_1/15
# y_range_2 = y_range_2/15

### 1000 Gauss ###
y_err_1 = np.sqrt(y_range_1)/10     #File: D1_1uW_1000Gauss_10sx3_QWP_1282022_12_20_11_02_run_1_Counts
y_err_2 = np.sqrt(y_range_2)/10     #File: D1_1uW_1000Gauss_10sx3_QWP_372022_12_20_11_50_run_1_Counts

y_range_1 = y_range_1/10
y_range_2 = y_range_2/10


### Plot Data
plt.errorbar(x_range_1, y_range_1, yerr=y_err_1, marker='o', markersize=10, color='crimson', alpha=0.6, linestyle='None', label='$\sigma+$') #, color='b'
plt.errorbar(x_range_2, y_range_2, yerr=y_err_2, marker='^', markersize=10, color='royalblue', alpha=0.6, linestyle='None', label='$\sigma-$') #, color='b'

### Plot Data
# plt.plot(x_range_1, y_range_1,'o', color='red', label='$\sigma+$') #label='$D1 - \sigma+$'
# plt.plot(x_range_2, y_range_2,"^", color='blue', label='$\sigma-$') #label='D1 - $\sigma-$'


# ## Define your parameters - Initial Guess
# ## 0 Gauss ###
# ## Sigma+
# x_1 = 234.423
# amp_1 = 88 #1*10^7     # counts
# y0_1 = 18 #4*10^7
# cen_1 = 234.425592  # THz
# wid_1 = 0.0001   # THz
# ## Sigma-
# x_2 = 234.423
# amp_2 = 88 #5*10^8     # counts
# y0_2 = 20 #35*10^8
# cen_2 = 234.425592  # THz
# wid_2 = 0.0001   # THz
#
## 600 Gauss ###
## Sigma+
# x_1 = 234.4234
# amp_1 = 85 #90 #3*10**8     # counts
# y0_1 = 26
# cen_1 = 234.42567  # THz
# wid_1 = 0.0001   # THz
# ## Sigma-
# x_2 = 234.4234
# amp_2 = 92 #3*10**8     # counts
# y0_2 = 25 #31 #6*10**7
# cen_2 = 234.42543  # THz
# wid_2 = 0.0001   # THz
# #
### 1000 Gauss ###
### Sigma+
x_1 = 234.4234
amp_1 = 92 #90 #3*10**8     # counts
y0_1 = 28
cen_1 = 234.4259  # THz
wid_1 = 0.0001   # THz
## Sigma-
x_2 = 234.4234
amp_2 = 92 #3*10**8     # counts
y0_2 = 30 #31 #6*10**7
cen_2 = 234.4253  # THz
wid_2 = 0.0001   # THz
#
#
def _1Lorentzian(x_1, amp_1, cen_1, wid_1):
    return y0_1 + amp_1 * wid_1 / ((x_1 - cen_1) ** 2 + wid_1 ** 2)

def _1Lorentzian_2(x_2, amp_2, cen_2, wid_2):
    return y0_2 + amp_2 * wid_2 / ((x_2 - cen_2) ** 2 + wid_2 ** 2)

popt_lorentzian, pcov_lorentzian = sp.optimize.curve_fit(_1Lorentzian, x_range_1, y_range_1, p0=[amp_1, cen_1, wid_1])
popt_lorentzian_2, pcov_lorentzian_2 = sp.optimize.curve_fit(_1Lorentzian_2, x_range_2, y_range_2, p0=[amp_2, cen_2, wid_2])
#
#
### Error
perr_lorentz = np.sqrt(np.diag(pcov_lorentzian))
perr_lorentz2 = np.sqrt(np.diag(pcov_lorentzian_2))

pars = popt_lorentzian[0:3]
HWHM = pars[2]*10**6 # pars[2])*10** to go from THz to MHz
FWHM = round(2*HWHM,2) # FWHM = 2xHWHM in MHz
Center = round(pars[1],6)

### Otpimal Parameters rounded to 2 digits precision
amp_opt = popt_lorentzian[0]
cen_opt = popt_lorentzian[1]
wid_opt = popt_lorentzian[2]

amp_opt2 = popt_lorentzian_2[0]
cen_opt2 = popt_lorentzian_2[1]
wid_opt2 = popt_lorentzian_2[2]

### Error of the  Parameters rounded to 2 digits precision
amp_opt_error = perr_lorentz[0]
cen_opt_error = perr_lorentz[1]
wid_opt_error = perr_lorentz[2]

amp_opt_error2 = perr_lorentz2[0]
cen_opt_error2 = perr_lorentz2[1]
wid_opt_error2 = perr_lorentz2[2]

### Extract FWHM and Center
HWHM= round(wid_opt*10**6,2) # *10**6 to go from THZ to MHz
FWHM = round(2*HWHM,2)
FWHM_err = round(2*wid_opt_error,6)
Center = round(cen_opt,6)
Center_err = round(cen_opt_error,6)

HWHM2 = round(wid_opt2*10**6,2)
FWHM2 = round(2*HWHM2,2)
FWHM_err2 = round(2*wid_opt_error2,6)
Center2 = round(cen_opt2,6)
Center_err2 = round(cen_opt_error2,6)

Splitting = round((Center - Center2)*10**6,0) # from THz to MHz
# ####################################################
# ## Print the fitting parameters with their errors ##
# ####################################################
print("-------------Lorentzian Fit-------------")
# print("Amplitude = %0.2f (+/-) %0.2f"' Cps' % (pars[0], perr_lorentz[0]))
# print("Center = %0.6f (+/-) %0.6f" ' THz'% (pars[1], perr_lorentz[1]))
# print("Width = %0.6f (+/-) %0.6f" ' THz'% (pars[2], perr_lorentz[2]))
print("HWHM_P1 = %0.6f " ' THz'% HWHM)
print("FWHM_P1 = %0.6f " ' MHz'% FWHM)
print("Center_P1 = %0.6f " ' THz'% Center)
print("--------------------------------")
print("HWHM_P2 = %0.6f " ' THz'% HWHM2)
print("FWHM_P2 = %0.6f " ' MHz'% FWHM2)
print("Center_P2 = %0.6f " ' THz'% Center2)
print("--------------------------------")
print("Splitting = %0.6f " ' MHz'% Splitting)
#
#
# ###########################
# # Plot the data & Labels ##
# ###########################
plt.plot(x_range_1,_1Lorentzian(x_range_1,*popt_lorentzian),'--',color='crimson') #label='Lorentzian fit' #+str(popt_lorentzian))
plt.plot(x_range_2,_1Lorentzian_2(x_range_2,*popt_lorentzian_2),'--',color='royalblue')

# ## Write Fitting Params on the graph
#plt.plot(x2,_decay(x2,*popt_decay),'--',color='orange', label='Fit. func: $f(x) = %.f * e^{%.3f x} %+.3f$' % (A_opt,-t_opt,b_opt)) #+str(popt_lorentzian))
plt.text(234.42213,100,f"FWHM_1 = {FWHM} $\pm$ {FWHM_err} MHz" + \
                        f"\nCenter_1 = {Center} $\pm$ {Center_err} THz"#+\
                        f"\n" +\
                        f"\nFWHM_2 = {FWHM2} $\pm$ {FWHM_err2} MHz" + \
                        f"\nCenter_2 = {Center2} $\pm$ {Center_err2} THz" #+ \
                        f"\n" + \
                        f"\nSplitting = {Splitting} MHz"
                        ,fontsize=14) ## Text inside the plot

#plt.style.use('classic')
plt.legend(prop={'size': 16})
plt.title('PLE_1000_Gauss')
plt.xlabel('Frequency (THz)', fontsize=16)
plt.ylabel(r'Intensity (Counts/s) ', fontsize=16) #($cps $)
plt.rc('font', family='sans-serif')
plt.rc('font', serif='Helvetica')
#plt.rc('font', serif='Helvetica')
#plt.ylabel(r'Normalized Intensity', fontsize=20) #($cps $)
#plt.ylabel(r'Power (uW) ', fontsize=16) #($cps $)
plt.xticks(fontsize = 16)
plt.yticks(fontsize = 16)
plt.show()